Subject: bug#61943: 29.0.60; icomplete--in-region-setup should activate icomplete-fido-mode-map too

From: João Távora <[email-masked]>
Date: Sat, 4 Mar 2023 11:30:48 +0000

On Sat, Mar 4, 2023 at 2:35 AM Sean Whitton <[email-masked]> wrote:
>
> Hello,
>
> On Fri 03 Mar 2023 at 11:18AM -07, Sean Whitton wrote:
>
> > X-debbugs-cc: [email-masked], [email-masked]
> >
> > Many thanks to Juri and Joao for fixing #45763!  It's a whole new world!
> >
> > I am a fido-mode user.  I noticed that my custom bindings for the
> > fido-mode minibuffer don't work for in-buffer completion.  I think that
> > icomplete--in-region-setup should compose in icomplete-fido-mode-map, in
> > addition to icomplete-minibuffer-map, in the case that fido-mode is on?
>
> I noticed that icomplete-hide-common-prefix etc. are wrong too.
> I think that icomplete--in-region-setup also needs to do something
> equivalent to the setq-local in icomplete--fido-mode-setup.

Yes, Sean, please report an Emacs -Q recipe for what you are trying
to get working.

I've now found a way to test this, and I was surprised at how easy it
was, but also skeptical.  As I remember analyzing it more than a year ago,
and finding this a reasonbaly hard job.  Also it seems to be completely
broken for fido-vertical mode and icomplete-vertical-mode, so I think
an approach that takes these cousin modes into consideration.

All in all, I'm not sure we should be shipping this half-baked
enhancement for emacs-29, at least not in this phase. I propose
we revert it in emacs-29.

I propose we revert it from there, keep the changes in master,
and focus on making it more consistent there.